這個頁面會逐步引導您部署 App Engine 標準或彈性環境應用程式,並使用 Identity-Aware Proxy (IAP) 保護其安全。本快速入門導覽課程包含 App Engine 標準環境網頁應用程式的程式碼範例,可驗證登入使用者的名稱。
若您預計從內容傳遞聯播網 (CDN) 提供資源,請參閱最佳做法指南取得重要資訊。
如要保護不在 Google Cloud上的資源,請參閱「保護地端部署應用程式和資源」。
事前準備
如要為 App Engine 啟用 IAP,請按照下列步驟操作:
使用已啟用計費功能的 Google Cloud 控制台專案。
如要使用 Google 代管的預設 OAuth 用戶端,請確認專案屬於 Google Cloud 機構。如果沒有機構,可以建立一個。如要瞭解使用自訂 OAuth 用戶端的優點,請參閱「為 App Engine 設定自訂 OAuth 用戶端」。Google 代管的 OAuth 用戶端僅允許內部使用者存取。
如果尚未設定 App Engine 執行個體,請先完成設定。如需完整逐步說明,請參閱「部署至 App Engine」。
啟用 IAP
控制台
如果專案不屬於任何機構,您必須使用自訂 OAuth 憑證。
If you haven't configured your project's OAuth consent screen, you'll be prompted to do so. To configure your OAuth consent screen, see Setting up your OAuth consent screen.
Setting up IAP access
-
Go to the
Identity-Aware Proxy page.
Go to the Identity-Aware Proxy page - Select the project you want to secure with IAP.
- Select the checkbox next to the resource you want to grant access to.
- On the right side panel, click Add principal.
-
In the Add principals dialog that appears, enter the email addresses of groups or
individuals who should have the IAP-secured Web App User role for the project.
The following kinds of principals can have this role:
- Google Account: user@gmail.com
- Google Group: admins@googlegroups.com
- Service account: server@example.
- Google Workspace domain: example.com
Make sure to add a Google Account that you have access to.
- Select Cloud IAP > IAP-secured Web App User from the Roles drop-down list.
- Click Save.
Turning on IAP
-
On the Identity-Aware Proxy page, under Applications,
find the application you want to restrict
access to. To turn on IAP for a resource,
-
In the Turn on IAP window that appears, click Turn On to
confirm that you want IAP to secure your resource. After you turn on
IAP, it requires login credentials for all connections to your load balancer.
Only principals with the IAP-Secured Web App User (
roles/iap.httpsResourceAccessor) role on the project will be given access.
gcloud
Before you set up your project and IAP, you need an up-to-date version of the gcloud CLI. For instructions on how to install the gcloud CLI, see Install the gcloud CLI.
-
To authenticate, use the Google Cloud CLI and run the following command.
gcloud auth login - Click the URL that appears and sign in.
- After you sign in, copy the verification code that appears and paste it in the command line.
-
Run the following command to specify the project that contains the applications that you want to protect with IAP.
gcloud config set project PROJECT_ID -
To enable IAP, run the following command.
gcloud iap web enable --resource-type=app-engine --versions=version -
Add principals who should have the IAP-secured Web App user role to the project.
gcloud projects add-iam-policy-binding PROJECT_ID \ --member=PRINCIPAL_IDENTIFIER \ --role=roles/iap.httpsResourceAccessor- Replace PROJECT_ID with your project ID.
- Replace PRINCIPAL_IDENTIFIER with the necessary principals. This can be a
type of domain, group, serviceAccount, or user. For example,
user:myemail@example.com.
After you enable IAP, you can use the gcloud CLI to modify the
IAP access policy using the IAM role
roles/iap.httpsResourceAccessor. Learn more about
managing roles and permissions.
API
Run the following command to prepare a
settings.jsonfile.cat << EOF > settings.json { "iap": { "enabled":true } } EOFRun the following command to enable IAP.
curl -X PATCH \ -H "Authorization: Bearer $(gcloud auth print-access-token)" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -d @settings.json \ "https://appengine.googleapis.com/v1/apps/PROJECT_ID?updateMask=iap"
After you enable IAP, you can use the Google Cloud CLI to modify the
IAP access policy using the IAM role
roles/iap.httpsResourceAccessor. Learn more about
managing roles and permissions.
您可以在專案中啟用 App Engine 服務的 IAP。如要公開存取部分服務,並要求其他服務進行驗證,您可以在服務之間使用不同的存取層級。詳情請參閱「使用 IAP 管理存取權」。如要公開存取服務,請將「受 IAP 保護的網頁應用程式使用者」角色授予 allAuthenticatedUsers。
測試使用者驗證
授予角色後,主體即可透過 IAP 驗證存取應用程式。使用已獲授「受 IAP 保護的網頁應用程式使用者」
roles/iap.httpsResourceAccessor角色的 Google 帳戶存取應用程式網址。如要測試存取權,請在 Chrome 中開啟無痕視窗,存取應用程式網址,並在系統提示時登入。獲得 「IAP-secured Web App User (
roles/iap.httpsResourceAccessor)」 角色的使用者,只要通過驗證即可存取應用程式。如果使用者 未獲得必要角色或驗證失敗,就無法存取 應用程式。
後續步驟
- 套用存取層級,設定更精細的情境規則。
- 請參閱「在 Cloud 稽核記錄中查看情境感知存取權記錄」。
- 進一步瞭解 IAP。
- 瞭解如何取得使用者身分識別資訊,並開發自己的 App Engine 應用程式。